#include <iostream>
#include <chrono>
//#include <geometry_msgs/PoseWithCovariance.h>
//#include <tf/transform_broadcaster.h>
#include <math.h>
#include <lTime.h>
#include <pthread.h>
#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/ioctl.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <sys/types.h>
#include <termios.h>
#include <time.h>
#include <unistd.h>
#include <queue>

#include "type_define.h"
#include "ESKF.h"
#include "utils.h"
#include "qrpconfig.h"

#include "init_inputs.h"
//#include "parseDataFiles.h"

#define SQ(x) (x*x)
#define GRAVITY 	9.8015  // local g value.
#define I_3 (Eigen::Matrix3f::Identity())

using namespace Eigen;
using namespace std;

FILE *fp_ins;
FILE *fp_pos_error;
FILE *fp_vel_error;
FILE *fp_lidar_atti;
FILE *fp_full_data;
FILE *fp_slam_data;
FILE *fp_est_slam_error;

FILE *fp_new_odom;
double slam_data[15];
//void postTF(ESKF eskf,tf::TransformBroadcaster tb,std::string name);
//double difference(ESKF eskfRef,ESKF eskfTest);
/*////////Q阵//////////////////////////////////////*/
float sigma_accl_noise;   // [m/s^2]  (value derived from Noise Spectral Density in datasheet)
float sigma_gyro_noise; // [rad/s] (value derived from Noise Spectral Density in datasheet)
float sigma_accl_drift; // [m/s^2 sqrt(s)] (Educated guess, real value to be measured)
float sigma_gyro_drift;  // [rad/s sqrt(s)] (Educated guess, real value to be measured)
/*///////P阵////*/
float sigma_init_pos;//(0.1*0.1,0.1*0.1,0.3*0.3); // [m]
float sigma_init_vel; // [m/s]
float sigma_init_dtheta; // [rad]
float sigma_init_accel_bias;//=0.0005*sigma_accel_drift; // [m/s^2]
float sigma_init_gyro_bias;//=0.0005*sigma_gyro_drift; //   [rad/s]
////////R阵/////////
Vector3f sigma_pos;
Vector3f sigma_theta; 
Vector3f sigma_vel;
int lidar_status=1;
float wheel_vel_range=0;    
////////imu-陀螺-加速度计零偏///////////////////////--(X=0.146914237,    Y=0.028846492	    Z=0.009          静态加速度数据求得零偏）
//     141     测试过                                             (X=0.000208758,    Y=0.001560938		Z=0.001652822,   静态陀螺零偏）
//Vector3f init_acc_bias(0.383022104,-0.199887576,0.0339);//
//Vector3f init_gyr_bias(0.00004797,-0.000019825,-0.00003970); 
//////////imu-陀螺-加速度计零偏///////////////////////////////////////////
/////  151
//Vector3f init_acc_bias(0.38818754,0.10599683,0.036);//
//Vector3f init_gyr_bias(0.00005608,0.00009468,-0.00004458);
//////////////////////////////////////////////////////
//(-0.00009468 	0.00005608 	-0.00004458 	-0.10599683 	0.38818754 	9.84701084 )(151)
////////////////// juran_in ////////////////////////////////////
//-0.0000369 	-0.0000537 	-0.0000429 	0.0308390 	0.4400045 	9.8342757 
//
//Vector3f init_acc_bias(0.4400045,-0.0308390,0.0325);//
//Vector3f init_gyr_bias(-0.0000537,0.0000369,-0.0000429); 
//////////////// juran _out ///////////////////////////////
//-0.00000002 	0.00005355 	-0.00005760 	0.21438969 	0.33742482 	9.83517782 
//Vector3f init_acc_bias(0.33742482,-0.21438969,0.0325);//
//Vector3f init_gyr_bias(0.00005355,0.00000002,-0.00005760); 
///////////////// fm0 /////////////////////////////////////
Vector3f init_acc_bias(0.399642704,-0.08396834,0.047);//
Vector3f init_gyr_bias(0.00000348,0.000153993,-0.00007214); 
//-0.00003352 	0.00019136 	-0.00007214 	0.05396834 	0.28615387 	9.85305580 
//-0.000153993	0.00000348 	-0.00005196 	0.08484575	0.399642704	9.847630614

Vector3f wheel_speed(0,0,0);
Vector3f imu2base;  //这是IMU与后轮中心坐标之间的安装角度误差
//imuData imu;
mocapData mocap;
//wheelData wheel;
int type;
Eigen::Quaternionf quad_init(1,0,0,0);
Vector3f pos_initial(0,0,0);
Vector3f vel_initial;
Eigen::Vector3f atti_ini;
Matrix3f Cbn;

Vector3f blh_tmp;
Vector3f DR_POS;
Quaternionf qq;
Vector3f DR_ATTI;

double wheel_ini_time;
double wheel_pre_time;

std::vector<IMURawData> imu_data;
std::vector<WheelRawData> wheel_data;
std::vector<IERawData> IE_data;
std::vector<OdometryRawData> odom_data;
std::vector<pos_atti_ini_RawData> pos_atti_ini_data;
std::vector<Imu2BaseRawData> imu2base_data;
std::vector<QRPConfigAutoData> qrpconfig_data;
std::vector<Imu2Base_LeverArmRawData> imu2base_lever_arm_data;
std::vector<OdometryRawData> slam_loc_data;

std::string imu_file_loc;
std::string wheel_file_loc;
std::string IE_file_loc;
std::string odom_file_loc;
std::string pos_atti_ini_loc;
std::string imu2base_loc;
std::string qrpconfig_loc;
std::string imu2base_lever_arm_loc;
std::string slam_loc_loc;
std::vector<TimedRawData> FullRawData;

FILE *fp_qrp;
FILE *fp_slam;
void *thread_nav_func(void *arg) 
{
    int flag =0;
    int R_cnt=0;
    float d_k=0;
    float b=0.95;
    int cnt=0;
    int wheel_cnt=0;

    atti_ini = pos_atti_ini_data[0].atti_ini;//{0.00097, 0.03636, 1.56218};//(0.00824, 0.02516, 1.45407)(juran_in);  
    imu2base = imu2base_data[0].imu2base_calib; 
   
    fp_ins = fopen("ins.txt", "w+");
    
    fp_pos_error = fopen("poserror.txt", "w+");
    fp_lidar_atti = fopen("fp_lidar_atti.txt", "w+");
    fp_slam_data = fopen("slamslam.txt","r+");
    fp_est_slam_error = fopen("est-slam-error.txt","w+");

    fp_new_odom = fopen("new_odom.txt","w+");

    double  int_heading; 
    double  wheel_range=0;   
  
    Eigen::Vector3f  eulerAngle=atti_ini;    
     
    Eigen::AngleAxisf rollAngle(AngleAxisf(eulerAngle(0),Vector3f::UnitX()));
    Eigen::AngleAxisf pitchAngle(AngleAxisf(eulerAngle(1),Vector3f::UnitY()));
    Eigen::AngleAxisf yawAngle(AngleAxisf(eulerAngle(2),Vector3f::UnitZ()));//-1.5999938
    Eigen::Quaternionf qq_init;
       
    qq_init = yawAngle*pitchAngle*rollAngle;     
    ///////////////////////imu的安装与车载系需要通过旋转矩阵矫正  此处IMU是右 前 上; 旋转矩阵进行了逆时针转了90度/////////////////////////////////   
    Eigen::Matrix3f Rot_imu_car;
    Eigen::AngleAxisf roll_imu(AngleAxisd(imu2base[0],Vector3d::UnitX()));
    Eigen::AngleAxisf pitch_imu(AngleAxisd(imu2base[1],Vector3d::UnitY()));
    Eigen::AngleAxisf yaw_imu(AngleAxisd(imu2base[2],Vector3d::UnitZ()));
    
    Rot_imu_car = yaw_imu*pitch_imu*roll_imu;          
    //////////////////////////四元数初始化//////////////////////////////////////////////// 
    quad_init = qq_init;  

    Cbn= quad_init.normalized().toRotationMatrix();
    vel_initial = {0,0,0};         //
    vel_initial = Cbn*vel_initial;       //
    wheel_speed =   vel_initial;
    ////////////量测R阵的初始化///////////////////////////////
    sigma_pos[0]  = pow(qrpconfig_data[0].sigma_pos_x[0],2); 
    sigma_pos[1]  = pow(qrpconfig_data[0].sigma_pos_y[0],2);
    sigma_pos[2]  = pow(qrpconfig_data[0].sigma_pos_z[0],2);

    sigma_theta[0]  = pow(qrpconfig_data[0].sigma_theta_roll[0],2);
    sigma_theta[1]  = pow(qrpconfig_data[0].sigma_theta_pitch[0],2);
    sigma_theta[2]  = pow(qrpconfig_data[0].sigma_theta_yaw[0],2);

    sigma_vel[0]    = pow(qrpconfig_data[0].sigma_vel_x[0],2);
    sigma_vel[1]    = pow(qrpconfig_data[0].sigma_vel_y[0],2);
    sigma_vel[2]    = pow(qrpconfig_data[0].sigma_vel_z[0],2);
    ////////////Q阵/--
    sigma_accl_noise = pow(qrpconfig_data[0].sigma_accl_noise,2);   //0.6   三个方向的Q值还是不一样的设置最好
    sigma_gyro_noise = pow(qrpconfig_data[0].sigma_gyro_noise,2);  //0.01，0.0085  
    sigma_accl_drift = pow(0.001,2)*sigma_accl_noise;//     
    sigma_gyro_drift = pow(0.001,2)*sigma_gyro_noise;//
     /////////////P阵的初始化//////////////////////////////////////////// 
    sigma_init_pos        = pow(qrpconfig_data[0].sigma_init_pos,2);    // pow(0.3,2)
    sigma_init_vel        = pow(qrpconfig_data[0].sigma_init_vel,2);    //   pow(5.35,2)
    sigma_init_dtheta     = pow(qrpconfig_data[0].sigma_init_dtheta,2); //pow(0.02,2)
    sigma_init_accel_bias = 10*sigma_accl_drift; //[m/s^2]10*sigma_accl_drift;
    sigma_init_gyro_bias  = 10*sigma_gyro_drift; //[m/s^2]10*sigma_gyro_drift;   
    //////////////////////////////////////////////////// 
    
    pos_initial = pos_atti_ini_data[0].pos_ini;//+Vector3f(-0.8,-0.2,-1.1);//{0.331, 0.780, -0.146};//{2.992, 0.228, -0.140}(juran_out);//{5.143, 19.984, -0.364}(juran_in);//{0.331, 0.780, -0.146}(141); //{0.058, -2.263, -0.073}(151);//
    //////////////////////////////////////////////////////////////////////////////////////////////////////
    ESKF eskfSpoof(
            Vector3f(0, 0, -GRAVITY), // Acceleration due to gravity in global frame
            ESKF::makeState(
                    pos_initial, // init pos
                    vel_initial, // init vel
                    quad_init, // init quaternion
                    init_acc_bias, // init accel bias
                    init_gyr_bias // init gyro bias
            ),
            ESKF::makeP(             //P0
                SQ(sigma_init_pos) * I_3,
                SQ(sigma_init_vel) * I_3,
                SQ(sigma_init_dtheta) * I_3,
                SQ(sigma_init_accel_bias) * I_3,
                SQ(sigma_init_gyro_bias) * I_3
            ),                  
                sigma_accl_noise,     //Q0
                sigma_gyro_noise,
                sigma_accl_drift,
                sigma_gyro_drift, 
                sigma_pos,            //R0
                sigma_theta,
                sigma_vel, 
                lidar_status,
                wheel_vel_range,            
                ESKF::delayTypes::noMethod,
                100,                
                imu2base_lever_arm_data[0].imu2base_lever_arm,
                &qrpconfig_data[0]);       //QRP config data
    double imu_first[3];
    int cnt_tmp;    
    cnt_tmp = 0;    
  
   
    lTime stamp;
    lTime now;
    while(1)
    {
         
        if(floor(FullRawData[cnt].unix_time)==(int)(FullRawData[FullRawData.size()-1].unix_time))//停车的时刻结束  1657787271（141）1657856030(151) 1655712871(JURAN_IN)
         {          
            pthread_exit(0);
         }           
         usleep(50);                      
            
        switch (FullRawData[cnt].type)
        {
            case IMU:                
            { 
                stamp = stamp.fromSec(FullRawData[cnt].unix_time);                
                now = stamp;
                Vector3f acc,gyr;
                acc = {FullRawData[cnt].imu.x_acc,FullRawData[cnt].imu.y_acc,FullRawData[cnt].imu.z_acc};
                gyr = {FullRawData[cnt].imu.x_angular,FullRawData[cnt].imu.y_angular,FullRawData[cnt].imu.z_angular};

                acc = Rot_imu_car*acc;
                gyr = Rot_imu_car*gyr;             

                eskfSpoof.updateImu(acc,gyr,now);
              
                DR_POS =  eskfSpoof.getNominalState().block<3,1>(POS_IDX,0);//-Vector3f(0.02,0.2,0);                              
              
                qq.w() = eskfSpoof.getNominalState().block<4, 1>(QUAT_IDX, 0)[0];
                qq.x() = eskfSpoof.getNominalState().block<4, 1>(QUAT_IDX, 0)[1];
                qq.y() = eskfSpoof.getNominalState().block<4, 1>(QUAT_IDX, 0)[2];
                qq.z() = eskfSpoof.getNominalState().block<4, 1>(QUAT_IDX, 0)[3];               

                Eigen::Vector3f EulaAngle = RotationQuaternionToEulerVector(qq);               
              
                printf(" pos = %.4f %.8f %.8f %.8f %.8f %.8f %.8f\n ",FullRawData[cnt].unix_time,DR_POS.x(),DR_POS.y(),DR_POS.z(),
                    EulaAngle.x(),EulaAngle.y(),EulaAngle.z());               
                    
                fprintf(fp_ins,"%.4f,%.6f,%.6f,%.6f,%.8f,%.8f,%.8f,%.8f,%.9f,%.9f,%.9f\n",FullRawData[cnt].unix_time,DR_POS.x(),DR_POS.y(),DR_POS.z(),
                qq.w(),qq.x(),qq.y(),qq.z(),EulaAngle.x()*57.29,EulaAngle.y()*57.29,EulaAngle.z()*57.29); 


                 break;
            }

            case WHEEL:               
            {
                if(wheel_cnt==1)
                {
                    wheel_cnt =1;
                    stamp = stamp.fromSec(FullRawData[cnt].unix_time);               
                    now = stamp;
                    double wheel_dt = FullRawData[cnt].unix_time - wheel_pre_time;
                    wheel_pre_time = FullRawData[cnt].unix_time;
                    wheel_speed[0] = FullRawData[cnt].wheel.movement/wheel_dt;
                    wheel_speed[1] = 0;
                    wheel_speed[2] = 0;
                
                    if(wheel_speed[0]<1)  
                    {
                        wheel_range = 1;
                    }else
                    {
                        wheel_range = 2;            
                    }
                                                                                        
                    eskfSpoof.measureWheel(wheel_speed,wheel_range,now);  
                
                    DR_POS =  eskfSpoof.getNominalState().block<3,1>(POS_IDX,0);//-Vector3f(0.02,0.2,0);                              
                    
                    qq.w() = eskfSpoof.getNominalState().block<4, 1>(QUAT_IDX, 0)[0];
                    qq.x() = eskfSpoof.getNominalState().block<4, 1>(QUAT_IDX, 0)[1];
                    qq.y() = eskfSpoof.getNominalState().block<4, 1>(QUAT_IDX, 0)[2];
                    qq.z() = eskfSpoof.getNominalState().block<4, 1>(QUAT_IDX, 0)[3];               

                    Eigen::Vector3f EulaAngle = RotationQuaternionToEulerVector(qq);  
                        
                 fprintf(fp_ins,"%.4f,%.6f,%.6f,%.6f,%.8f,%.8f,%.8f,%.8f,%.9f,%.9f,%.9f\n",FullRawData[cnt].unix_time,DR_POS.x(),DR_POS.y(),DR_POS.z(),
                 qq.w(),qq.x(),qq.y(),qq.z(),EulaAngle.x()*57.29,EulaAngle.y()*57.29,EulaAngle.z()*57.29); 

                }else
                {
                    wheel_cnt++;  
                }               

                break;
            }
            case ODOM:           
            {  
                stamp = stamp.fromSec(FullRawData[cnt].unix_time); 
                now = stamp;                                             
                mocap.quat.w()  = FullRawData[cnt].odom.qw;
                mocap.quat.x()  = FullRawData[cnt].odom.qx;
                mocap.quat.y()  = FullRawData[cnt].odom.qy;
                mocap.quat.z()  = FullRawData[cnt].odom.qz;
              
                mocap.pos = {FullRawData[cnt].odom.x,FullRawData[cnt].odom.y,FullRawData[cnt].odom.z};
                Eigen::Vector3f EulaAngle_lidar = RotationQuaternionToEulerVector(mocap.quat);               
              
                fprintf(fp_lidar_atti,"%.4f,%.8f,%.8f,%.8f,%.8f,%.8f,%.8f\n",FullRawData[cnt].unix_time,mocap.pos.x(),mocap.pos.y(),mocap.pos.z(),
                    EulaAngle_lidar[0]*57.29,EulaAngle_lidar[1]*57.29,EulaAngle_lidar[2]*57.29);   

                mocap.status = 1;//FullRawData[cnt].odom.
                                                                
                   
               /* Vector3f lidar_angle,delta_pos,angle_error;
                lidar_angle = RotationQuaternionToEulerVector(mocap.quat);   
                angle_error = lidar_angle - eskfSpoof.lidar_last_angle;
                eskfSpoof.lidar_last_angle = lidar_angle;

                delta_pos = mocap.pos - eskfSpoof.getPos();
                double error = sqrt(pow(delta_pos[0],2)+pow(delta_pos[1],2));*/
                
                ////////////////////////// imu to base yaw error///////////////////////////////////////////////////////
                               
                /*Eigen::Vector3f EulaAngle_old_odom = RotationQuaternionToEulerVector(mocap.quat);
               
                Eigen::Vector3f EulaAngle_new_odom = Vector3f(EulaAngle_old_odom[0],EulaAngle_old_odom[1],EulaAngle_old_odom[2]-1/57.29);
                
                Eigen::Quaternionf qq_lidar_base;
                Eigen::AngleAxisf roll_imu(AngleAxisd(EulaAngle_new_odom[0],Vector3d::UnitX()));
                Eigen::AngleAxisf pitch_imu(AngleAxisd(EulaAngle_new_odom[1],Vector3d::UnitY()));
                Eigen::AngleAxisf yaw_imu(AngleAxisd(EulaAngle_new_odom[2],Vector3d::UnitZ()));   //there is a yaw error about 1 degree between base and wheel

                qq_lidar_base = yaw_imu*pitch_imu*roll_imu;

                mocap.quat = qq_lidar_base;*/
                /////////////////////////////////////////////////////////////////////////////////////    
                
                   
                eskfSpoof.measureLidar(mocap.quat,mocap.pos,mocap.status,now);  
              
                Quaternionf qqq;
                qqq.w() = eskfSpoof.getNominalState().block<4, 1>(QUAT_IDX, 0)[0];
                qqq.x() = eskfSpoof.getNominalState().block<4, 1>(QUAT_IDX, 0)[1];
                qqq.y() = eskfSpoof.getNominalState().block<4, 1>(QUAT_IDX, 0)[2];
                qqq.z() = eskfSpoof.getNominalState().block<4, 1>(QUAT_IDX, 0)[3];               

                Eigen::Vector3f EulaAngle1 = RotationQuaternionToEulerVector(qqq);               
              
               Eigen::Vector3f est_tmp,atti_tmp;
               Eigen::Vector3f error_tmp,error_atti_tmp;
               
               est_tmp = eskfSpoof.getNominalState().block<3,1>(POS_IDX,0);  
               atti_tmp =  EulaAngle1;         
               error_tmp  = est_tmp-mocap.pos;
               error_atti_tmp = EulaAngle1 - EulaAngle_lidar;

               if(floor(FullRawData[cnt].unix_time)<(int)(FullRawData[FullRawData.size()-1].unix_time))
               {
                  
                  fprintf(fp_pos_error,"%.8f,%.4f,%.4f,%.4f,%.9f,%.9f,%.9f\n",FullRawData[cnt].unix_time,error_tmp.x(),error_tmp.y(),error_tmp.z(),
                       error_atti_tmp[0]*57.29,error_atti_tmp[1]*57.29,error_atti_tmp[2]*57.29);
                    
               }

                DR_POS =  eskfSpoof.getNominalState().block<3,1>(POS_IDX,0);//-Vector3f(0.02,0.2,0);                              
                
                qq.w() = eskfSpoof.getNominalState().block<4, 1>(QUAT_IDX, 0)[0];
                qq.x() = eskfSpoof.getNominalState().block<4, 1>(QUAT_IDX, 0)[1];
                qq.y() = eskfSpoof.getNominalState().block<4, 1>(QUAT_IDX, 0)[2];
                qq.z() = eskfSpoof.getNominalState().block<4, 1>(QUAT_IDX, 0)[3];               

                Eigen::Vector3f EulaAngle = RotationQuaternionToEulerVector(qq); 
                
                fprintf(fp_ins,"%.4f,%.6f,%.6f,%.6f,%.8f,%.8f,%.8f,%.8f,%.9f,%.9f,%.9f\n",FullRawData[cnt].unix_time,DR_POS.x(),DR_POS.y(),DR_POS.z(),
                qq.w(),qq.x(),qq.y(),qq.z(),EulaAngle.x()*57.29,EulaAngle.y()*57.29,EulaAngle.z()*57.29);                

                if(FullRawData[cnt].unix_time>1656052329.6)
                {
                     fscanf(fp_slam_data,"%lf,%lf,%lf,%lf,%lf,%lf,%lf,%lf,%lf,%lf,%lf\n",&slam_data[0],&slam_data[1],&slam_data[2],&slam_data[3],
                 &slam_data[4],&slam_data[5],&slam_data[6],&slam_data[7],&slam_data[8],&slam_data[9],&slam_data[10]);

                    fprintf(fp_est_slam_error,"%.3f,%.4f,%.4f,%.4f,%.4f,%.4f,%.4f\n",FullRawData[cnt].unix_time,DR_POS.x()-slam_data[1],DR_POS.y()-slam_data[2],
                    DR_POS.z()-slam_data[3],EulaAngle.x()*57.29-slam_data[8],EulaAngle.y()*57.29-slam_data[9],EulaAngle.z()*57.29-slam_data[10]);
                }
                              
                break;
            }
            case GNSS:
                 //ss="GNSS";
                 break;
            default:
                 break;            
        }            
           
            cnt=cnt+1;
            
    }
   pthread_exit(0);
}

int main(int argc, char** argv) 
{    
   
    imu_file_loc = argv[1];
    imu_file_loc = imu_file_loc+"/imu.txt";
    wheel_file_loc = argv[1];
    wheel_file_loc = wheel_file_loc+"/wheel.txt";
    odom_file_loc = argv[1];
    odom_file_loc = odom_file_loc+"/odom.txt";
    pos_atti_ini_loc = argv[1];
    pos_atti_ini_loc = pos_atti_ini_loc+"/init_pose.txt";
    imu2base_loc = argv[1];
    imu2base_loc = imu2base_loc+"/imu2base.calib";
    qrpconfig_loc = argv[1];
    qrpconfig_loc = qrpconfig_loc+"/qrpconfig_auto.txt";
    imu2base_lever_arm_loc = argv[1];
    imu2base_lever_arm_loc = imu2base_lever_arm_loc+"/imu2base_lever_arm.txt";
    slam_loc_loc = argv[1];
    slam_loc_loc = slam_loc_loc+"/slam.txt";
    
    char path[100];
    
    strcpy(path,qrpconfig_loc.c_str());    
    fp_qrp = fopen(path, "r");
    fp_full_data = fopen("full.txt","w+");    
    fp_slam = fopen("slamslam.txt","w+");
   
    Pos_Atti_Ini_FileReader file_pos_atti_ini;
    file_pos_atti_ini.loadPos_Atti_Ini_File(pos_atti_ini_loc,0,pow(2,64)); 
    pos_atti_ini_data = file_pos_atti_ini.raw_data;
    cout<<pos_atti_ini_data[0].atti_ini<<endl;

    Imu2BaseFileReader file_imu2base;
    file_imu2base.loadImu2BaseFile(imu2base_loc);
    imu2base_data = file_imu2base.raw_data;
    cout<<imu2base_data[0].imu2base_calib<<endl;

    Imu2Base_LeverArmFileReader file_imu2base_lever_arm;
    file_imu2base_lever_arm.loadImu2Base_LeverArmFile(imu2base_lever_arm_loc);
    imu2base_lever_arm_data = file_imu2base_lever_arm.raw_data;
    cout<<imu2base_lever_arm_data[0].imu2base_lever_arm<<endl;

    QRPConfigFileReader file_qrpconfig;
    file_qrpconfig.loadQRPConfigAutoFile(fp_qrp);
    qrpconfig_data = file_qrpconfig.auto_data;

    IMUFileReader file_imu;
    file_imu.loadIMUFile(imu_file_loc,MODE_ROBOSM1,0,pow(2,64));    
    imu_data = file_imu.raw_data;
    for(auto imu : imu_data)
    {
           FullRawData.emplace_back(imu);           
    }

    WheelFileReader file_wheel;
    file_wheel.loadWheelFile(wheel_file_loc,0,pow(2,64));
    wheel_data = file_wheel.raw_data;  
    for(auto wheel : wheel_data)
    {
           FullRawData.emplace_back(wheel);           
    }

    OdometryFileReader file_odom;
    file_odom.loadOdometryFile(odom_file_loc,0,pow(2,64));
    odom_data = file_odom.raw_data;
    for(auto odom : odom_data)
    {
           FullRawData.emplace_back(odom);           
    }    
    //////////////////// slam file transform///////////////////////////////
    OdometryFileReader file_slam_loc;
    file_slam_loc.loadOdometryFile(slam_loc_loc,0,pow(2,64));    
    slam_loc_data = file_slam_loc.raw_data;
    cout<<"slam_loc_data = "<<slam_loc_data[0].x<<endl;

    Eigen::Vector3f  eulerAngle=Vector3f(0,0,-1.6011); //这是slam的map系转localU的yaw角变换   
     
    Eigen::AngleAxisf rollAngle(AngleAxisf(eulerAngle(0),Vector3f::UnitX()));
    Eigen::AngleAxisf pitchAngle(AngleAxisf(eulerAngle(1),Vector3f::UnitY()));
    Eigen::AngleAxisf yawAngle(AngleAxisf(eulerAngle(2),Vector3f::UnitZ()));
    Eigen::Quaternionf qq_init;
       
    qq_init = yawAngle*pitchAngle*rollAngle;     
    
    Eigen::Matrix3f Rot_slam2base;
    
    Rot_slam2base = yawAngle*pitchAngle*rollAngle; 
    Eigen::Vector3f slam_pos;
    Eigen::Quaternionf slam_quad,slam_quad_new;
    Eigen::Quaternionf slam_quad_inver;
    Eigen::Matrix3f rotation_matrix;
    Eigen::Matrix3f new_rotation_matrix;
    for(int i=0;i<slam_loc_data.size();i++)
    {
        slam_pos[0] = slam_loc_data[i].x;
        slam_pos[1] = slam_loc_data[i].y;
        slam_pos[2] = slam_loc_data[i].z;

        //slam_pos = Rot_slam2base*slam_pos;
        slam_quad.w() = slam_loc_data[i].qw;
        slam_quad.x() = slam_loc_data[i].qx;
        slam_quad.y() = slam_loc_data[i].qy;
        slam_quad.z() = slam_loc_data[i].qz;

        
        /*rotation_matrix= slam_quad.toRotationMatrix();
        new_rotation_matrix = Rot_slam2base*rotation_matrix;
        
        
        slam_quad_inver.w() =  quaternion.w();
        slam_quad_inver.x() =  quaternion.x();
        slam_quad_inver.y() =  quaternion.y();
        slam_quad_inver.z() =  quaternion.z();

        slam_quad_new = qq_init*slam_quad*slam_quad_inver;*/
        
        Eigen::Vector3f EulaAngle_2 = RotationQuaternionToEulerVector(slam_quad);

        
        fprintf(fp_slam,"%.4f,%7f,%7f,%7f,%7f,%7f,%7f,%7f,%7f,%7f,%7f\n",slam_loc_data[i].unix_time,slam_pos[0],slam_pos[1],slam_pos[2],
                slam_quad.w(),slam_quad.x(),slam_quad.y(),slam_quad.z(),EulaAngle_2[0]*57.29,EulaAngle_2[1]*57.29,EulaAngle_2[2]*57.29);
    }



    ////////////////////////////////////////////////////
    std::sort(FullRawData.begin(), FullRawData.end(), std::less<TimedRawData>());
    char* ss;
    bool wheel_ini_time_enable = true;
    for(int i=0;i<FullRawData.size();i++)
    {
        switch (FullRawData[i].type)
        {
            case IMU:
                 ss="IMU";
                 fprintf(fp_full_data,"%.4f,%s,%.7f,%.7f,%.7f,%.7f,%.7f,%.7f\n",FullRawData[i].unix_time,ss,FullRawData[i].imu.x_angular,
                 FullRawData[i].imu.y_angular,FullRawData[i].imu.z_angular,FullRawData[i].imu.x_acc,
                 FullRawData[i].imu.y_acc,FullRawData[i].imu.z_acc);
               //  printf("imu %lf\n",FullRawData[i].unix_time);
                 break;
            case WHEEL:
                 ss="WHEEL";
                 fprintf(fp_full_data,"%.4f,%s,%.7f\n",FullRawData[i].unix_time,ss,FullRawData[i].wheel.movement);
                 if(wheel_ini_time_enable)
                 {
                         wheel_ini_time = FullRawData[i].wheel.unix_time;
                         wheel_ini_time_enable = false;
                    
                 }    
               //  printf("wheel %lf\n",FullRawData[i].unix_time);
                 break;
            case ODOM:
                 ss="ODOM";                
                 fprintf(fp_full_data,"%.4f,%s,%.7f\n",FullRawData[i].unix_time,ss,FullRawData[i].odom.x);
               //  printf("odom %lf\n",FullRawData[i].unix_time);
                 break;
            case GNSS:
                 ss="GNSS";
                 break;
            default:
                 break;            
        }
           
        //fprintf("utc-time = %.7f type = %s\n",FullRawData[i].unix_time,ss);
        //usleep(50000);
    }
    
    wheel_pre_time = wheel_ini_time;
    //IEFileReader file_IE;
    //file_IE.loadIEFile(IE_file_loc)

    //FullRawData
    pthread_t thread_t_nav;
   
    int ret = pthread_create(&thread_t_nav, NULL, thread_nav_func, NULL);

    if (ret != 0) {
        printf("creat pthread error!\n");
        exit(1);
    }
   pthread_join(thread_t_nav, NULL);
   return 0;

}

double difference(ESKF eskfRef,ESKF eskfTest){
    Vector3f posRef = eskfRef.getPos();
    Vector3f posTest = eskfTest.getPos();
    Vector3f out = posTest - posRef;
    return out.norm();
}

/*void postTF(ESKF eskf,tf::TransformBroadcaster tb,std::string name){
    tf::StampedTransform pred;
    Vector3d pos = eskf.getPos();
    Quaterniond quat = eskf.getQuat();
    pred.setOrigin(tf::Vector3(pos[0],pos[1],pos[2]));
    pred.setRotation(tf::Quaternion(quat.x(),quat.y(),quat.z(),quat.w()));
    //pred.stamp_ = ros::Time::now();
    pred.frame_id_ = "mocha_world";
    pred.child_frame_id_ = name;
    tb.sendTransform(pred);
}*/
