#pragma once

#include <pcl/point_types.h>
#include <pcl/point_cloud.h>

typedef pcl::PointXYZI PointJ;
typedef pcl::PointCloud<PointJ> PointCloudJ;

struct PointRos {
    PCL_ADD_POINT4D
    float intensity;
    float ring;
    float label = 0;
    float timestamp;
    EIGEN_MAKE_ALIGNED_OPERATOR_NEW  // make sure our new allocators are aligned
} EIGEN_ALIGN16;

POINT_CLOUD_REGISTER_POINT_STRUCT(
    PointRos, (float, x, x)(float, y, y)(float, z, z)
        (float, intensity, intensity)(float, ring, ring)(float, label, label)
        (float, timestamp, timestamp))

