#include "cloud_receiver.h"

namespace juefx{

CloudReceiver::CloudReceiver(const SysController::Ptr &sys)
    : SensorSubscriber(sys)
{
    boost::function<void(const PointCloudInter&, double)> cloudCallback =
            boost::bind(&CloudReceiver::Callback, this, _1, _2);
    DataReader::Instance()->registCloudCb(cloudCallback);
}

void CloudReceiver::Callback(const PointCloudInter &cloud, double currCloudTime)
{
    CloudPacketPtr packet(new CloudPacket);
    packet->sensorDataType = CLOUD_DATA;
    packet->cloud = cloud;
    packet->timestamp = currCloudTime;
    sys_->OnNewDataReceived(packet);
}

} // end of namespace
