#include "imu_receiver.h"

namespace juefx{

IMUReceiver::IMUReceiver(const SysController::Ptr &sys)
    : SensorSubscriber(sys)
{
    boost::function<void(const IMURawData&)> imuCallback =
            boost::bind(&IMUReceiver::Callback, this, _1);
    DataReader::Instance()->registImuCb(imuCallback);
}

void IMUReceiver::Callback(
        const IMURawData &iMURawData)
{
    IMUPacketPtr packet(new IMUPacket);
    packet->sensorDataType = IMU_DATA;
    packet->timestamp = iMURawData.unix_time;
    packet->angular_velocity = {(float)iMURawData.x_angular,
                                (float)iMURawData.y_angular,
                                (float)iMURawData.z_angular};
    packet->linear_acceleration = {(float)iMURawData.x_acc,
                                   (float)iMURawData.y_acc,
                                   (float)iMURawData.z_acc};
    sys_->OnNewDataReceived(packet);
}

} // end of namespace
