#ifndef CLOUDSUBSCRIBER_H
#define CLOUDSUBSCRIBER_H
#include <sensor_msgs/PointCloud2.h>
#include "ros_subscriber.h"
#include "../../localize_utils/pcl_point_type.h"

using CloudT = sensor_msgs::PointCloud2;
namespace juefx{
class CloudSubscriber : public RosSubscriber
{
public:
    using Ptr = boost::shared_ptr<CloudSubscriber>;
    CloudSubscriber(const SysController::Ptr &sys,
                    ros::NodeHandle* node_handle,
                    const std::string& topic = "");

    ~CloudSubscriber(){
        _subscriber.reset();
    }

    void StartListeningToRos() override;

private:
    void Callback(const CloudT::Ptr &msg);

    PointCloudInter RosCloudToCloud(const CloudT::Ptr &msg);

private:
    using Subscriber = message_filters::Subscriber<CloudT>;
    typedef boost::shared_ptr<Subscriber> SubscriberPtr;
    SubscriberPtr _subscriber;
};

} // end of namespace
#endif // CLOUDSUBSCRIBER_H
