#include "gnss_subscriber.h"
namespace juefx{

GNSSSubscriber::GNSSSubscriber(
        const SysController::Ptr &sys,
        ros::NodeHandle* node_handle,
        const std::string& topic)
    :RosSubscriber(sys, node_handle, topic)
{
    StartListeningToRos();
}

void GNSSSubscriber::StartListeningToRos()
{
    _subscriber.reset(new Subscriber(
        *_node_handle, _topic, _msg_queue_size));
    _subscriber->registerCallback(
        &GNSSSubscriber::Callback, this);
}

void GNSSSubscriber::Callback(const NavSatFixT::Ptr &msg)
{
    if(msg->status.status < 0){
        return;
    }
    GNSSPacketPtr packet(new GNSSPacket);
    packet->sensorDataType = GNSS_DATA;
    packet->timestamp = msg->header.stamp.toSec();
    packet->blh = {msg->latitude,
                  msg->longitude,
                  msg->altitude};
    packet->status = msg->status.status;
    sys_->OnNewDataReceived(packet);
}

} // end of namespace
