#ifndef GNSSSUBSCRIBER_H
#define GNSSSUBSCRIBER_H
#include <sensor_msgs/NavSatFix.h>
#include "ros_subscriber.h"
namespace juefx{

using NavSatFixT = sensor_msgs::NavSatFix;
class GNSSSubscriber : public RosSubscriber
{
public:
    using Ptr = boost::shared_ptr<GNSSSubscriber>;
    GNSSSubscriber(const SysController::Ptr &sys,
                   ros::NodeHandle* node_handle,
                   const std::string& topic = "");

    ~GNSSSubscriber(){
        _subscriber.reset();
    }

    void StartListeningToRos() override;

private:
    void Callback(const NavSatFixT::Ptr &msg);


private:
    using Subscriber = message_filters::Subscriber<NavSatFixT>;
    typedef boost::shared_ptr<Subscriber> SubscriberPtr;
    SubscriberPtr _subscriber;
};

} // end of namespace
#endif // GNSSSUBSCRIBER_H
