﻿#ifndef IMUSUBSCRIBER_H
#define IMUSUBSCRIBER_H
#include <sensor_msgs/Imu.h>
#include "ros_subscriber.h"

using ImuT = sensor_msgs::Imu;
namespace juefx{

class IMUSubscriber : public RosSubscriber
{
public:
    using Ptr = boost::shared_ptr<IMUSubscriber>;
    IMUSubscriber(const SysController::Ptr &sys,
                  ros::NodeHandle* node_handle,
                  const std::string& topic = "");

    ~IMUSubscriber(){
        _subscriber.reset();
    }

    void StartListeningToRos() override;

private:
    void Callback(const ImuT::Ptr &msg);


private:    
    using Subscriber = message_filters::Subscriber<ImuT>;
    typedef boost::shared_ptr<Subscriber> SubscriberPtr;
    SubscriberPtr _subscriber;
};

} // end of namespace
#endif // IMUSUBSCRIBER_H
