#ifndef IMUPOSE_SUBSCRIBER_H
#define IMUPOSE_SUBSCRIBER_H

#include <geometry_msgs/PoseStamped.h>
#include "ros_subscriber.h"

using PoseT = geometry_msgs::PoseStamped;
namespace juefx{

class IMUPoseSubscriber : public RosSubscriber
{
public:
    using Ptr = boost::shared_ptr<IMUPoseSubscriber>;
    IMUPoseSubscriber(const SysController::Ptr &sys,
                      ros::NodeHandle* node_handle,
                      const std::string& topic = "");

    ~IMUPoseSubscriber(){
        _subscriber.reset();
    }

    void StartListeningToRos() override;

private:
    void Callback(const PoseT::Ptr &msg);


private:
    using Subscriber = message_filters::Subscriber<PoseT>;
    typedef boost::shared_ptr<Subscriber> SubscriberPtr;
    SubscriberPtr _subscriber;
};

} // end of namespace
#endif // IMUPOSE_SUBSCRIBER_H
