#ifndef ROSSUBSCRIBER_H
#define ROSSUBSCRIBER_H

#include <ros/ros.h>
#include <message_filters/subscriber.h>
#include <message_filters/synchronizer.h>
#include <message_filters/sync_policies/approximate_time.h>
#include <visualization_msgs/Marker.h>
#include <pcl_ros/point_cloud.h>

#include "../sensor_subscriber.h"

namespace juefx{

class RosSubscriber : public SensorSubscriber
{
public:
    RosSubscriber(const SysController::Ptr &sys,
                  ros::NodeHandle* node_handle,
                  const std::string& topic = "");

    virtual void StartListeningToRos() = 0;

protected:
    ros::NodeHandle* _node_handle;

    string _topic;

    uint32_t _msg_queue_size;

};

} // end of namespace
#endif // ROSSUBSCRIBER_H
