#include "wheel_subscriber.h"
namespace juefx{

WheelSubscriber::WheelSubscriber(
        const SysController::Ptr &sys,
        ros::NodeHandle* node_handle,
        const std::string& topic)
    :RosSubscriber(sys, node_handle, topic)
{
    StartListeningToRos();
}

void WheelSubscriber::StartListeningToRos()
{
    _subscriber.reset(new Subscriber(
        *_node_handle, _topic, _msg_queue_size));
    _subscriber->registerCallback(
        &WheelSubscriber::Callback, this);

}

void WheelSubscriber::Callback(const OdomT::Ptr &msg)
{
    WheelPacketPtr packet(new WheelPacket);
    packet->sensorDataType = WHEEL_DATA;
    packet->timestamp = msg->header.stamp.toSec();
    packet->linear = {msg->twist.twist.linear.x,
                     msg->twist.twist.linear.y,
                     msg->twist.twist.linear.z};


//    LOG(INFO) << setprecision(15) << "wheel," << packet->timestamp << ","
//        << msg->twist.twist.linear.x << "," << msg->twist.twist.linear.y << ","
//        << msg->twist.twist.linear.z << endl;
    sys_->OnNewDataReceived(packet);

}

} // end of namespace
