#ifndef WHEELSUBSCRIBER_H
#define WHEELSUBSCRIBER_H
#include <nav_msgs/Odometry.h>
#include "ros_subscriber.h"

using OdomT = nav_msgs::Odometry;
namespace juefx{

class WheelSubscriber : public RosSubscriber
{
public:
    using Ptr = boost::shared_ptr<WheelSubscriber>;
    WheelSubscriber(const SysController::Ptr &sys,
                    ros::NodeHandle* node_handle,
                    const std::string& topic = "");

    ~WheelSubscriber(){
        _subscriber.reset();
    }

    void StartListeningToRos() override;

private:
    void Callback(const OdomT::Ptr &msg);


private:
    using Subscriber = message_filters::Subscriber<OdomT>;
    typedef boost::shared_ptr<Subscriber> SubscriberPtr;
    SubscriberPtr _subscriber;
};

} // end of namespace
#endif // WHEELSUBSCRIBER_H
