#ifndef ROSBAG_READER_H
#define ROSBAG_READER_H

#include "../sensor_subscriber.h"
#include <rosbag/bag.h>
#include <rosbag/view.h>
#include <sensor_msgs/PointCloud2.h>
#include <sensor_msgs/Imu.h>
#include <nav_msgs/Odometry.h>
#include <sensor_msgs/NavSatFix.h>
#include <pcl_conversions/pcl_conversions.h>

using CloudT = sensor_msgs::PointCloud2;
using ImuT = sensor_msgs::Imu;
using OdomT = nav_msgs::Odometry;
using NavSatFixT = sensor_msgs::NavSatFix;
namespace juefx{

class RosBagReader : public SensorSubscriber
{
public:
    RosBagReader(const SysController::Ptr &sys,
                 const string &bagPath);

    ~RosBagReader();

    void Play();
private:
    rosbag::Bag bag_;
};
}
#endif // ROSBAG_READER_H
