#ifndef CLOUDPREPROCESS_H
#define CLOUDPREPROCESS_H

#include "localize_utils/utils.h"
#include "localize_utils/pcl_point_type.h"
#include "system/parameter.h"
#include "state/state.h"
#include "pcl/common/transforms.h"

namespace juefx{

class CloudPreprocess
{
public:
    using Ptr = boost::shared_ptr<CloudPreprocess>;
    CloudPreprocess();

    static CloudPreprocess::Ptr Instance();

    static PointCloudInter::Ptr GetBaseFrame(const CloudPacket &cloudData);

    static bool Undisort(PointCloudInter::Ptr &input, PointCloudJ::Ptr &undisortedFrame,
                  PointCloudJ *mappedFrame, double frameTime,
                  const vector<IsometryData> *periodPoseVec,
                  Isometry3d &framePose, Isometry3d &increasePose);
};

} // end of namespace
#endif // CLOUDPREPROCESS_H
