#ifndef IMUCALIBER_H
#define IMUCALIBER_H

#include "localize_utils/utils.h"
#include "system/parameter.h"
#include "state/state.h"

namespace juefx{

class ImuCaliber
{
public:
    using Ptr = boost::shared_ptr<ImuCaliber>;
    ImuCaliber();

    void Reset();

    static ImuCaliber::Ptr Instance();

    bool CalculateImuPose(const IMUPacket &imu);

private:
    uint16_t dataCnt_ = 0;

    Vector3f meanAcc_ = Vector3f::Zero();
};

} // end of namespace
#endif // IMUCALIBER_H
