#include "frame_cloud.h"

#include "icp_pair.h"

namespace juefx
{

bool transfer_cloud_to_vector(pcl::PointCloud<pcl::PointXYZI>::ConstPtr pcloud, VectorCloud &vector_cloud)
{
    if (pcloud->points.size() == 0)
        return false;

    PointCloudN::Ptr cloud = cloud_calculate_normal(pcloud);
    vector_cloud.reserve(cloud->points.size());
    for (auto &point : cloud->points)
    {
        VectorCloudPoint p;
        p.P = Eigen::Vector3d(point.x, point.y, point.z);
        p.N = Eigen::Vector3d(point.normal_x, point.normal_y, point.normal_z);
        p.distance = point.intensity;
        p.curvature = point.curvature;
        vector_cloud.push_back(p);
    }
    return true;
}

}