#pragma once

#include "frame_cloud.h"

#define PAIR_TYPE_TOP_TOP 0
#define PAIR_TYPE_TOP_BACK 1

namespace juefx
{

// point cloud type
typedef pcl::PointXYZINormal PointN;
typedef pcl::PointCloud<PointN> PointCloudN;

struct IcpPair
{
    const FrameCloud *frame_s; // source Frame cloud
    const FrameCloud *frame_q; // query Frame cloud
    int index_s;
    int index_q;
    int8_t distance;
    int8_t type;
    bool is_ground;
    bool is_long;
};

struct IcpPairSet
{
    std::string name;
    std::vector<IcpPair> pairs;
};

PointCloudN::Ptr cloud_calculate_normal(pcl::PointCloud<pcl::PointXYZI>::ConstPtr cloud_in);

// used in calculate close point
void get_closest_points(const FrameCloud *source_frame, const FrameCloud *query_frame,
                        bool need_sample, double distance_thresh, int thread_num, IcpPairSet &pair_set);
}