#pragma once

#include "matcher_interface.h"
#include "raw_icp/frame_cloud.h"

namespace juefx {

class RawICPMatcher : public MatcherInterface
{
public:
    RawICPMatcher() : map_frame_(0, 0) {}
    ~RawICPMatcher() {}

    void LoadPointCloudMap(const PointCloudJ::Ptr pcloud_map);
    float MatchPointCloud(const PointCloudJ::Ptr pcloud, const Eigen::Isometry3f init_pose,
                          Eigen::Isometry3f &final_pose);
    float MatchMultiPointCloud(std::vector<PointCloudJ::ConstPtr> target,
                               std::vector<PointCloudJ::ConstPtr> source,
                               const Eigen::Isometry3f init_pose,
                               Eigen::Isometry3f &final_pose);

private:
    FrameCloud map_frame_;
};

}
