#pragma once

#include "matcher_interface.h"

namespace juefx {

struct VicpMatcherOption {
    float register_voxel_resolution = 1;
    int threads_num = 10;
};

class VicpMatcher : public MatcherInterface
{
public:
    VicpMatcher(const VicpMatcherOption& option);

    void LoadPointCloudMap(const PointCloudJ::Ptr pcloud_map,
                           float resolution);
    float MatchPointCloud(const PointCloudJ::Ptr pcloud,
                          const Eigen::Isometry3f init_pose,
                          Eigen::Isometry3f &final_pose);

private:
    PointCloudJ::Ptr pcloudMap_;
    VicpMatcherOption option_;
};

}