#pragma once
#ifndef GRIDMANAGER_H
#define GRIDMANAGER_H

#include "grid.h"
#include "utils/pcl_point_type.h"
#include "gridlayer.h"

class BlockGrid;

class GridManager
{
public:
    GridManager(const float sideLength,
                const vector<double> resolutions);

    Vector2i getGridIndexByPoint(
            const PointExport &point,
            size_t layerLevel);

    void setOrigin(const Vector2f &origin);

    void setSideLength(float sideLength);

    vector<boost::shared_ptr<GridLayer> > getLayers() const;

    void addLayer(const double &resolution);
protected:
    Vector2f origin_ = Vector2f::Zero();


    float sideLength_;

    vector<boost::shared_ptr<GridLayer>> layers_;

    const vector<double> resolutions_;

};

#endif // GRIDMANAGER_H
