#include "block.h"

BlockGrid::BlockGrid(const Vector2i &index,
        const float &sideLength,
        const vector<double> &resolutions)
    :GridBase(index, sideLength),
      GridManager(sideLength, resolutions)
{
    setOrigin(GridBase::origin_);
}

void BlockGrid::configInfo()
{
//    blockInfo_.set_local_offset_x(GridBase::center_.x());
//    blockInfo_.set_local_offset_y(GridBase::center_.y());

    for(auto layer : layers_){
        auto gridGrids = layer->getGridMap();
        auto iter = gridGrids->begin();
        BlockDistribution_ blockDistribution;
        blockDistribution.gridDistributions.resize(pow(round(BlockResolution / layer->getResolution()), 2));
        for( ; iter != gridGrids->end(); iter++){
            Grid* grid = reinterpret_cast<Grid*>(iter->second.get());
            grid->configInfo();
            if(grid->getHasGround()){
                hasGround_ = true;
            }
            auto distributions = grid->getGridDistribution();
            uint32_t grid_id = iter->first;
            blockDistribution.gridDistributions.at(grid_id) = *distributions;
        }
        layersDistribution_.push_back(blockDistribution);
    }
}

vector<BlockDistribution_> BlockGrid::getLayersDistributions()
{
    return layersDistribution_;
}

bool BlockGrid::IsHasGround()
{
    return hasGround_;
}


