#pragma once
#ifndef BLOCK_H
#define BLOCK_H

#include "gridbase.h"
#include "grid.h"
#include "gridmanager.h"
#include "block/block_info.pb.h"

class BlockGrid : public GridBase, public GridManager
{
public:
    BlockGrid(const Vector2i &index,
              const float &sideLength,
              const vector<double> &resolutions);

    void configInfo();

    vector<BlockDistribution_> getLayersDistributions();

    bool IsHasGround();


    inline juefx::GridData getGridData(
            uint8_t type,
            const juefx::GridIndex::ShortId &gridIndex)
    {
        juefx::GridData ret;
        boost::shared_ptr<GridLayer> blockLayer;
        if(type == 0){
            blockLayer = layers_[1];
        }else if(type == 1){
            blockLayer = layers_[0];
        }else{
            return ret;
        }
        boost::shared_ptr<GridBase> gridGrid;
        if(!blockLayer->getGrid({gridIndex.x, gridIndex.y}, gridGrid)){
            return ret;
        }
        auto grid = reinterpret_cast<Grid*>(gridGrid.get());
        return grid->getGridData();
    }
private:

    vector<BlockDistribution_> layersDistribution_;

    bool hasGround_ = false;

};//end of class


#endif // BLOCK_H
