#ifndef GRID_H
#define GRID_H

#include "gridbase.h"
#include "utils/basic_functions.h"
#include "distribution/distribution.pb.h"

class Grid : public GridBase
{
public:
    Grid(const Vector2i &index, const float &resolution);

    void addPoint(const PointExport &point);

    PointCloudExport::Ptr getPointCloud();

    void configInfo();

    boost::shared_ptr<GridDistribution_> getGridDistribution();

    inline juefx::GridData getGridData() const
    {
        return gridData_;
    }

    void setGridDistribution(const GridDistribution_ &gridDtribution);

    bool getHasGround();

private:
    PointCloudExport::Ptr pointcloud_;

    boost::shared_mutex insertMtx_;

    boost::shared_ptr<GridDistribution_> gridDtribution_;

    bool hasGround_ = false;

    juefx::GridData gridData_;

};

#endif // GRID_H
