#ifndef AREAMANAGER_H
#define AREAMANAGER_H

#include "utils/basic_functions.h"

namespace localize {

class AreaManager
{
public:
    AreaManager(const uint32_t &rowItemCnt,
                const uint32_t &colItemCnt);

    AreaManager();

    void setItemCnt(const uint32_t &rowItemCnt,
                    const uint32_t &colItemCnt);

    pair<uint32_t, uint32_t> getItemCnt(){
        return make_pair(rowItemCnt_, colItemCnt_);
    }

    virtual void backendFunc(uint8_t type, Vector2d point = Vector2d::Zero()) = 0;
protected:
    uint32_t rowItemCnt_ = 0;

    uint32_t colItemCnt_ = 0;
};

}

#endif // AREAMANAGER_H
