#ifndef BLOCKSERIALIZER_H
#define BLOCKSERIALIZER_H

#include "grid/gridmanager.h"
#include "grid/block.h"

class BlockSerializer
{
public:
    BlockSerializer(
            boost::shared_ptr<GridLayer> gridLayer);

    void configSerialization();

    void setOffset(const Vector3d &offset);

    void setMeshId(const string &meshId);

    void setBLH(const Vector3d& blh);

    void setOutputPath(const string& outputPath);
private:

private:
    boost::shared_ptr<GridLayer> meshLayer_;

    vector<locate::IndexDistribution> indexDistributionVec_;

    boost::shared_mutex mtx_;

    Vector3d offset_ = Vector3d::Zero();

    string meshId_;

    Vector3d blh_;

    string outputPath_;

};

#endif // BLOCKSERIALIZER_H
